import { BackendIdentifier, DeploymentType } from '@aws-amplify/plugin-types';
export type DeployProps = {
    deploymentType?: DeploymentType;
    secretLastUpdated?: Date;
    validateAppSources?: boolean;
};
export type DeployResult = {
    deploymentTimes: DeploymentTimes;
};
export type DestroyProps = {
    deploymentType?: DeploymentType;
};
export type DestroyResult = {
    deploymentTimes: DeploymentTimes;
};
export type DeploymentTimes = {
    synthesisTime?: number;
    totalTime?: number;
};
/**
 * Invokes an invokable command
 */
export type BackendDeployer = {
    deploy: (backendId?: BackendIdentifier, deployProps?: DeployProps) => Promise<DeployResult>;
    destroy: (backendId?: BackendIdentifier, destroyProps?: DestroyProps) => Promise<DestroyResult>;
};
/**
 * Factory to create a backend deployer
 */
export declare class BackendDeployerFactory {
    private static instance;
    /**
     * Returns a single instance of BackendDeployer
     */
    static getInstance: () => BackendDeployer;
}
//# sourceMappingURL=cdk_deployer_singleton_factory.d.ts.map